"get.ends" <-
function(x, p, du, step, b.limit){
  
    m = ncol(du)
    D = nrow(du)
    n = length(x)
    
    ## make sure p start from a value < step
    p = p - floor(min(p)/step)*step
    
    ## how many steps altogether
    Z = ceiling(max(p)/step)

    ## step indicator, every 'step' bp is one step
    stp = ceiling(p/step)
    
    ## check that for the input data, every step have at least 3 observations
    len = tapply(p, stp, length)
    if(any(len<3)){
        stop("there is at least one step with less than 3 observations\n")
    }
    
    ## indicator of end of every step
    dif = diff(stp)
    stp.end = c(which(dif>0), length(stp)) - 1
    
    x.ends = matrix(0, nrow=Z*m, ncol=Z)
    x.ends.idx = matrix(0, nrow=Z*m, ncol=Z)

    dims = c(n, m, D, Z, step)
    SW = .C("get_ends", as.double(x), as.double(p), as.integer(stp.end), 
        as.integer(dims), as.double(t(du)), xEnds = as.double(t(x.ends)), 
        xEndsIdx = as.integer(t(x.ends.idx)), as.double(b.limit),
        PACKAGE="ss.hmm")

    x.ends = matrix(SW$xEnds, byrow=TRUE, nrow=Z*m, ncol=Z)
    x.ends.idx = matrix(SW$xEndsIdx, byrow=TRUE, nrow=Z*m, ncol=Z)

    ends = list()
    for(i in 1:m){
        ends[[i]] = x.ends[((i-1)*Z+1):(i*Z),]
    }
    rm(x.ends)
    
    ends.idx = list()
    for(i in 1:m){
        ends.idx[[i]] = x.ends.idx[((i-1)*Z+1):(i*Z),]
    }
    rm(x.ends.idx)
    
    list(end=ends, idx=ends.idx)
}
