"plot.hmm.path" <-
function(hmmPath, dat.col="orange", fit.col="seagreen"){
    path = hmmPath$path
    step = hmmPath$step
    p    = hmmPath$p
    x    = hmmPath$x
    seg  = hmmPath$segment
    D1   = length(path)
    
    min.x = min(x)
    max.x = max(x)
    rag.x = max.x - min.x
    
    plot(p, x, ylim = c(min.x-0.2*rag.x, max.x), type="l", col=dat.col, 
        xlab = "position", ylab="signal")
    xS = step*(1:D1) - step/2
    
    states = unique(path)
    rbcols = rainbow(length(states))
    for(i in 1:length(states)){
        st = states[i]
        xI = xS[path==st]
        yI = rep(min.x-0.1*rag.x, length(xI))
        points(xI, yI, pch=as.character(st), col=rbcols[i])
    }
    
    lines(seg$p*step, seg$x, lty=2, col=fit.col)
    
    ## add the beginning segment of fitted line
    p2 = seg[nrow(seg),1]*step
    x2 = seg[nrow(seg),2]
    kp = which(p<=p2)
    if(length(kp)>1){
        xk = x[kp]
        pk = p[kp]
        l  = lm(xk~pk)
        p1 = min(p)
        x1 = l$coef[1] + l$coef[2]*p1
        lines(c(p1, p2), c(x1, x2), lty=2, col=fit.col)
    }

}
